package sorts;

import util.OArrays;

/**
 * Sort.java
 * Created by Stijn Strickx on May 21, 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */

/**
 * The datatype conversions for the arrays won't influence 
 * the time complexity of the sorting algorithms.
 * Without these conversions,
 * the algorithms would have to be re-written for every primitive datatype.
 */

public class Sort {
    
    public static <T extends Comparable<? super T>> void mergeSort(T[] a){
        (new MergeSort()).sort(a);
    }
    public static int[] mergeSort(int[] a){
        Integer[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static long[] mergeSort(long[] a){
        Long[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static double[] mergeSort(double[] a){
        Double[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static float[] mergeSort(float[] a){
        Float[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static char[] mergeSort(char[] a){
        Character[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static boolean[] mergeSort(boolean[] a){
        Boolean[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static byte[] mergeSort(byte[] a){
        Byte[] b = OArrays.toObjectArray(a);
        mergeSort(b);
        return OArrays.toPrimitiveArray(b);
    }
}